#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ArchivedStatus {
    #[serde(rename = "NOT_ARCHIVED")]
    NotArchived,
    #[serde(rename = "ARCHIVED")]
    Archived,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ArchivedStatus {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ArchivedStatus::NotArchived => "NOT_ARCHIVED",
            ArchivedStatus::Archived => "ARCHIVED",
            ArchivedStatus::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ArchivedStatus {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ArchivedStatus {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ArchivedStatus {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ArchivedStatus, conjure_object::plain::ParseEnumError> {
        match v {
            "NOT_ARCHIVED" => Ok(ArchivedStatus::NotArchived),
            "ARCHIVED" => Ok(ArchivedStatus::Archived),
            v => v.parse().map(|v| ArchivedStatus::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ArchivedStatus {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ArchivedStatus, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ArchivedStatus enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
